package oopsla.bpmn.diagram.part;

import oopsla.bpmn.Association;
import oopsla.bpmn.BpmnPackage;
import oopsla.bpmn.DataExclusiveGateway;
import oopsla.bpmn.DataObject;
import oopsla.bpmn.EndEvent;
import oopsla.bpmn.IntermediateEvent;
import oopsla.bpmn.MessageFlow;
import oopsla.bpmn.ParallelGateway;
import oopsla.bpmn.Pool;
import oopsla.bpmn.SequenceFlow;
import oopsla.bpmn.StartEvent;
import oopsla.bpmn.Task;

import oopsla.bpmn.diagram.edit.parts.AssociationEditPart;
import oopsla.bpmn.diagram.edit.parts.DataExclusiveGatewayEditPart;
import oopsla.bpmn.diagram.edit.parts.DataObjectEditPart;
import oopsla.bpmn.diagram.edit.parts.DataObjectNameEditPart;
import oopsla.bpmn.diagram.edit.parts.DiagramEditPart;
import oopsla.bpmn.diagram.edit.parts.EndEventEditPart;
import oopsla.bpmn.diagram.edit.parts.IntermediateEventEditPart;
import oopsla.bpmn.diagram.edit.parts.MessageFlowEditPart;
import oopsla.bpmn.diagram.edit.parts.ParallelGatewayEditPart;
import oopsla.bpmn.diagram.edit.parts.PoolEditPart;
import oopsla.bpmn.diagram.edit.parts.ProcessEditPart;
import oopsla.bpmn.diagram.edit.parts.SequenceFlowEditPart;
import oopsla.bpmn.diagram.edit.parts.StartEventEditPart;
import oopsla.bpmn.diagram.edit.parts.TaskEditPart;
import oopsla.bpmn.diagram.edit.parts.TaskNameEditPart;

import org.eclipse.core.runtime.Platform;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented 
 * by a domain model object.
 *
 * @generated
 */
public class BpmnVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = BpmnDiagramEditorPlugin
			.getInstance().getBundle().getSymbolicName()
			+ "/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (DiagramEditPart.MODEL_ID.equals(view.getType())) {
				return DiagramEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				BpmnDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		EClass domainElementMetaclass = domainElement.eClass();
		return getDiagramVisualID(domainElement, domainElementMetaclass);
	}

	/**
	 * @generated
	 */
	private static int getDiagramVisualID(EObject domainElement,
			EClass domainElementMetaclass) {
		if (BpmnPackage.eINSTANCE.getDiagram().isSuperTypeOf(
				domainElementMetaclass)
				&& isDiagramDiagram_1000((oopsla.bpmn.Diagram) domainElement)) {
			return DiagramEditPart.VISUAL_ID;
		}
		return getUnrecognizedDiagramID(domainElement);
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		EClass domainElementMetaclass = domainElement.eClass();
		return getNodeVisualID(containerView, domainElement,
				domainElementMetaclass, null);
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView,
			EObject domainElement, EClass domainElementMetaclass,
			String semanticHint) {
		String containerModelID = getModelID(containerView);
		if (!DiagramEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (DiagramEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = DiagramEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		int nodeVisualID = semanticHint != null ? getVisualID(semanticHint)
				: -1;
		switch (containerVisualID) {
		case PoolEditPart.VISUAL_ID:
			if ((semanticHint == null || ProcessEditPart.VISUAL_ID == nodeVisualID)
					&& BpmnPackage.eINSTANCE.getProcess().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeProcess_3001((oopsla.bpmn.Process) domainElement))) {
				return ProcessEditPart.VISUAL_ID;
			}
			return getUnrecognizedPool_2001ChildNodeID(domainElement,
					semanticHint);
		case ProcessEditPart.VISUAL_ID:
			if ((semanticHint == null || TaskEditPart.VISUAL_ID == nodeVisualID)
					&& BpmnPackage.eINSTANCE.getTask().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeTask_3002((Task) domainElement))) {
				return TaskEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || StartEventEditPart.VISUAL_ID == nodeVisualID)
					&& BpmnPackage.eINSTANCE.getStartEvent().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeStartEvent_3003((StartEvent) domainElement))) {
				return StartEventEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || EndEventEditPart.VISUAL_ID == nodeVisualID)
					&& BpmnPackage.eINSTANCE.getEndEvent().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeEndEvent_3004((EndEvent) domainElement))) {
				return EndEventEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ParallelGatewayEditPart.VISUAL_ID == nodeVisualID)
					&& BpmnPackage.eINSTANCE.getParallelGateway()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeParallelGateway_3005((ParallelGateway) domainElement))) {
				return ParallelGatewayEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || DataExclusiveGatewayEditPart.VISUAL_ID == nodeVisualID)
					&& BpmnPackage.eINSTANCE.getDataExclusiveGateway()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeDataExclusiveGateway_3006((DataExclusiveGateway) domainElement))) {
				return DataExclusiveGatewayEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || DataObjectEditPart.VISUAL_ID == nodeVisualID)
					&& BpmnPackage.eINSTANCE.getDataObject().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeDataObject_3007((DataObject) domainElement))) {
				return DataObjectEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || IntermediateEventEditPart.VISUAL_ID == nodeVisualID)
					&& BpmnPackage.eINSTANCE.getIntermediateEvent()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeIntermediateEvent_3008((IntermediateEvent) domainElement))) {
				return IntermediateEventEditPart.VISUAL_ID;
			}
			return getUnrecognizedProcess_3001ChildNodeID(domainElement,
					semanticHint);
		case TaskEditPart.VISUAL_ID:
			if (TaskNameEditPart.VISUAL_ID == nodeVisualID) {
				return TaskNameEditPart.VISUAL_ID;
			}
			return getUnrecognizedTask_3002ChildNodeID(domainElement,
					semanticHint);
		case StartEventEditPart.VISUAL_ID:
			return getUnrecognizedStartEvent_3003ChildNodeID(domainElement,
					semanticHint);
		case EndEventEditPart.VISUAL_ID:
			return getUnrecognizedEndEvent_3004ChildNodeID(domainElement,
					semanticHint);
		case ParallelGatewayEditPart.VISUAL_ID:
			return getUnrecognizedParallelGateway_3005ChildNodeID(
					domainElement, semanticHint);
		case DataExclusiveGatewayEditPart.VISUAL_ID:
			return getUnrecognizedDataExclusiveGateway_3006ChildNodeID(
					domainElement, semanticHint);
		case DataObjectEditPart.VISUAL_ID:
			if (DataObjectNameEditPart.VISUAL_ID == nodeVisualID) {
				return DataObjectNameEditPart.VISUAL_ID;
			}
			return getUnrecognizedDataObject_3007ChildNodeID(domainElement,
					semanticHint);
		case IntermediateEventEditPart.VISUAL_ID:
			return getUnrecognizedIntermediateEvent_3008ChildNodeID(
					domainElement, semanticHint);
		case DiagramEditPart.VISUAL_ID:
			if ((semanticHint == null || PoolEditPart.VISUAL_ID == nodeVisualID)
					&& BpmnPackage.eINSTANCE.getPool().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodePool_2001((Pool) domainElement))) {
				return PoolEditPart.VISUAL_ID;
			}
			return getUnrecognizedDiagram_1000ChildNodeID(domainElement,
					semanticHint);
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		EClass domainElementMetaclass = domainElement.eClass();
		return getLinkWithClassVisualID(domainElement, domainElementMetaclass);
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement,
			EClass domainElementMetaclass) {
		if (BpmnPackage.eINSTANCE.getSequenceFlow().isSuperTypeOf(
				domainElementMetaclass)
				&& (domainElement == null || isLinkWithClassSequenceFlow_4001((SequenceFlow) domainElement))) {
			return SequenceFlowEditPart.VISUAL_ID;
		} else if (BpmnPackage.eINSTANCE.getAssociation().isSuperTypeOf(
				domainElementMetaclass)
				&& (domainElement == null || isLinkWithClassAssociation_4002((Association) domainElement))) {
			return AssociationEditPart.VISUAL_ID;
		} else if (BpmnPackage.eINSTANCE.getMessageFlow().isSuperTypeOf(
				domainElementMetaclass)
				&& (domainElement == null || isLinkWithClassMessageFlow_4003((MessageFlow) domainElement))) {
			return MessageFlowEditPart.VISUAL_ID;
		} else {
			return getUnrecognizedLinkWithClassID(domainElement);
		}
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isDiagramDiagram_1000(oopsla.bpmn.Diagram element) {
		return true;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedDiagramID(EObject domainElement) {
		return -1;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodePool_2001(Pool element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeProcess_3001(oopsla.bpmn.Process element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeTask_3002(Task element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeStartEvent_3003(StartEvent element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeEndEvent_3004(EndEvent element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeParallelGateway_3005(ParallelGateway element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeDataExclusiveGateway_3006(
			DataExclusiveGateway element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeDataObject_3007(DataObject element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeIntermediateEvent_3008(
			IntermediateEvent element) {
		return true;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedPool_2001ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedProcess_3001ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedTask_3002ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedStartEvent_3003ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedEndEvent_3004ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedParallelGateway_3005ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedDataExclusiveGateway_3006ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedDataObject_3007ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedIntermediateEvent_3008ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedDiagram_1000ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedLinkWithClassID(EObject domainElement) {
		return -1;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isLinkWithClassSequenceFlow_4001(SequenceFlow element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isLinkWithClassAssociation_4002(Association element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isLinkWithClassMessageFlow_4003(MessageFlow element) {
		return true;
	}
}
