package oopsla.bpmn.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;
import oopsla.bpmn.BpmnPackage;

import oopsla.bpmn.diagram.expressions.BpmnAbstractExpression;
import oopsla.bpmn.diagram.expressions.BpmnOCLFactory;

import oopsla.bpmn.diagram.part.BpmnDiagramEditorPlugin;

import org.eclipse.emf.ecore.EObject;

/**
 * @generated
 */
public class BpmnElementTypes {

	/**
	 * @generated
	 */
	private BpmnElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			element = ((EStructuralFeature) element).getEContainingClass();
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return BpmnDiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap();
			elements.put(Diagram_1000, BpmnPackage.eINSTANCE.getDiagram());
			elements.put(Process_3001, BpmnPackage.eINSTANCE.getProcess());
			elements.put(Task_3002, BpmnPackage.eINSTANCE.getTask());
			elements
					.put(StartEvent_3003, BpmnPackage.eINSTANCE.getStartEvent());
			elements.put(EndEvent_3004, BpmnPackage.eINSTANCE.getEndEvent());
			elements.put(ParallelGateway_3005, BpmnPackage.eINSTANCE
					.getParallelGateway());
			elements.put(DataExclusiveGateway_3006, BpmnPackage.eINSTANCE
					.getDataExclusiveGateway());
			elements
					.put(DataObject_3007, BpmnPackage.eINSTANCE.getDataObject());
			elements.put(IntermediateEvent_3008, BpmnPackage.eINSTANCE
					.getIntermediateEvent());
			elements.put(Pool_2001, BpmnPackage.eINSTANCE.getPool());
			elements.put(SequenceFlow_4001, BpmnPackage.eINSTANCE
					.getSequenceFlow());
			elements.put(Association_4002, BpmnPackage.eINSTANCE
					.getAssociation());
			elements.put(MessageFlow_4003, BpmnPackage.eINSTANCE
					.getMessageFlow());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	public static final IElementType Diagram_1000 = getElementType("oopsla.bpmn.diagram.Diagram_1000"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType Process_3001 = getElementType("oopsla.bpmn.diagram.Process_3001"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType Task_3002 = getElementType("oopsla.bpmn.diagram.Task_3002"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType StartEvent_3003 = getElementType("oopsla.bpmn.diagram.StartEvent_3003"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType EndEvent_3004 = getElementType("oopsla.bpmn.diagram.EndEvent_3004"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType ParallelGateway_3005 = getElementType("oopsla.bpmn.diagram.ParallelGateway_3005"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType DataExclusiveGateway_3006 = getElementType("oopsla.bpmn.diagram.DataExclusiveGateway_3006"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType DataObject_3007 = getElementType("oopsla.bpmn.diagram.DataObject_3007"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType IntermediateEvent_3008 = getElementType("oopsla.bpmn.diagram.IntermediateEvent_3008"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType Pool_2001 = getElementType("oopsla.bpmn.diagram.Pool_2001"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType SequenceFlow_4001 = getElementType("oopsla.bpmn.diagram.SequenceFlow_4001"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType Association_4002 = getElementType("oopsla.bpmn.diagram.Association_4002"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType MessageFlow_4003 = getElementType("oopsla.bpmn.diagram.MessageFlow_4003"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	private static Set KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet();
			KNOWN_ELEMENT_TYPES.add(Diagram_1000);
			KNOWN_ELEMENT_TYPES.add(Process_3001);
			KNOWN_ELEMENT_TYPES.add(Task_3002);
			KNOWN_ELEMENT_TYPES.add(StartEvent_3003);
			KNOWN_ELEMENT_TYPES.add(EndEvent_3004);
			KNOWN_ELEMENT_TYPES.add(ParallelGateway_3005);
			KNOWN_ELEMENT_TYPES.add(DataExclusiveGateway_3006);
			KNOWN_ELEMENT_TYPES.add(DataObject_3007);
			KNOWN_ELEMENT_TYPES.add(IntermediateEvent_3008);
			KNOWN_ELEMENT_TYPES.add(Pool_2001);
			KNOWN_ELEMENT_TYPES.add(SequenceFlow_4001);
			KNOWN_ELEMENT_TYPES.add(Association_4002);
			KNOWN_ELEMENT_TYPES.add(MessageFlow_4003);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static class Initializers {

		/**
		 * @generated
		 */
		public static final ObjectInitializer EndEvent_3004 = new ObjectInitializer(
				new FeatureInitializer[] { new FeatureInitializer(
						BpmnOCLFactory.getExpression("EventType::END", //$NON-NLS-1$
								BpmnPackage.eINSTANCE.getEndEvent()),
						BpmnPackage.eINSTANCE.getEvent_EventType()) });

		/**
		 * @generated
		 */
		public static final ObjectInitializer IntermediateEvent_3008 = new ObjectInitializer(
				new FeatureInitializer[] { new FeatureInitializer(
						BpmnOCLFactory.getExpression("EventType::INTERMEDIATE", //$NON-NLS-1$
								BpmnPackage.eINSTANCE.getIntermediateEvent()),
						BpmnPackage.eINSTANCE.getEvent_EventType()) });

		/** 
		 * @generated
		 */
		private Initializers() {
		}

		/** 
		 * @generated
		 */
		public static class ObjectInitializer {
			/** 
			 * @generated
			 */
			private FeatureInitializer[] initExpressions;

			/** 
			 * @generated
			 */
			ObjectInitializer(FeatureInitializer[] initExpressions) {
				this.initExpressions = initExpressions;
			}

			/** 
			 * @generated
			 */
			public void init(EObject instance) {
				for (int i = 0; i < initExpressions.length; i++) {
					FeatureInitializer nextExpr = initExpressions[i];
					try {
						nextExpr.init(instance);
					} catch (RuntimeException e) {
						BpmnDiagramEditorPlugin.getInstance().logError(
								"Feature initialization failed", e); //$NON-NLS-1$						
					}
				}
			}
		} // end of ObjectInitializer

		/** 
		 * @generated
		 */
		static class FeatureInitializer {

			/** 
			 * @generated
			 */
			private EStructuralFeature sFeature;

			/** 
			 * @generated
			 */
			private BpmnAbstractExpression expression;

			/**
			 * @generated
			 */
			FeatureInitializer(BpmnAbstractExpression expression,
					EStructuralFeature sFeature) {
				this.sFeature = sFeature;
				this.expression = expression;
			}

			/** 
			 * @generated
			 */
			void init(EObject contextInstance) {
				expression.assignTo(sFeature, contextInstance);
			}
		} // end of FeatureInitializer
	} // end of Initializers
}
